<!--- 
	csw-herocarousel.cfc
	
	This is the core rendering for the Hero Carousel widget.
	
	Version: [2018-01-17 9:40]
--->

<cfcomponent displayname="csw-herocarousel" output="false" hint="Common Hero Carousel Functions" extends="_cs_widgets._common.csw-common">

	<cffunction name="loadResources" access="public" output="Yes" returntype="void">
		<cfscript>
			// load Resources
			Server.CommonSpot.udf.resources.loadResources("JQuery");
			Server.CommonSpot.udf.resources.loadResources("Bootstrap");
			Server.CommonSpot.udf.resources.loadResources("swiper");
			Server.CommonSpot.udf.resources.loadResources("cswCommonStyles");
			Server.CommonSpot.udf.resources.loadResources("cswTextStyles");
			Server.CommonSpot.udf.resources.loadResources("cswButtonStyles");
			Server.CommonSpot.udf.resources.loadResources("cswHeroCarousel");

			// If a custom stylesheets have been registered, go ahead and load them.
			if( StructKeyExists(Request.Site.CS_Resources.Resources_by_name,'cswCommonStyles_custom') )
				Server.CommonSpot.udf.resources.loadResources("cswCommonStyles_custom");
			if( StructKeyExists(Request.Site.CS_Resources.Resources_by_name,'cswTextStyles_custom') )
				Server.CommonSpot.udf.resources.loadResources("cswTextStyles_custom");
			if( StructKeyExists(Request.Site.CS_Resources.Resources_by_name,'cswButtonStyles_custom') )
				Server.CommonSpot.udf.resources.loadResources("cswButtonStyles_custom");
			if( StructKeyExists(Request.Site.CS_Resources.Resources_by_name,'cswHeroCarousel_custom') )
				Server.CommonSpot.udf.resources.loadResources("cswHeroCarousel_custom"); //  Custom override specific to this widget
		</cfscript>
		
	</cffunction>
	
	
	<cffunction name="loadProperties" access="public" returntype="struct" output="Yes">
		<cfargument name="elementInfo" type="struct" required="Yes">
		<cfargument name="rhCaller" type="struct" required="false" default="#StructNew()#">
		<cfargument name="showDataError" type="boolean" required="false" default="true">
		
		<cfscript>
			var widgetMetadataFormName = "CSW Hero Carousel";
			var props = StructNew();
			var rhMetadata = arguments.ElementInfo.RenderHandlerMetaData;
			var widgetData = StructNew();
			
			/*
			var props.enableButtonIcon = false;
			var props.enableResponsiveHorizontalButtons = false;
			var props.themeClass = "";
			var props.buttonBoxBlockClass = "";
			var props.buttonBlockClass = "";
			var props.buttonSizeClass = "";
			var props.themeClass = "";
			*/
			
			
			// Check for Props and Layout Binding
			if( NOT hasPropsLayoutBinding(ElementInfo=arguments.elementInfo,metadataFormName=widgetMetadataFormName,rhCaller=arguments.rhCaller) )
				return props;
			
			// 
			// Get Metadata (Core Hero Carousel metadata)
			// ---------------------------------------------
			widgetData = rhMetadata[widgetMetadataFormName];
			
			// Theme
			if( StructKeyExists(widgetData,"Theme") )
				props.themeClass = TRIM(widgetData.Theme);
				
			
			/**** CSW CAROUSEL TAB *****/
			
			/* ========================*/
			/*  Carousel Options       */
			/* =======================*/
			
			// props.showdots = false;
			props.showarrows = false;
			props.autoplay = false;
//			props.draggable = false;
			props.showthumbs = false;
			props.infiniteloop = false;
			props.autoheight = false;
			props.fixedheight = false;
			props.fixedHeightClass = '';
			props.dotsClass = '';
			
			if ( StructKeyExists(widgetData,"options") ) 
			
				props.OptionData = widgetData.Options;
				
				{
					if( FindNoCase("showarrows",props.OptionData))
						props.showarrows = true; 
						
//					if( FindNoCase("showdots",props.OptionData))
//					{
//						props.showdots = true; 
//						props.dotsClass = 'cswDotsPadding';
//					}
						
					if( FindNoCase("infiniteloop",props.OptionData))
						props.infiniteloop = true;
						
					if( FindNoCase("fixedheight",props.OptionData))
					{
						props.fixedheight = true;
						props.fixedHeightClass = 'props.OptionData';
					}	
					
					if( FindNoCase("showthumbs",props.OptionData))
						props.showthumbs = true;		 
			
					if( FindNoCase("autoheight",props.OptionData))
						props.autoheight = true;		 
				}

			// Slide Wait Time
			props.slideWaitTime = getStandardField( widgetData=widgetData, field='slideWaitTime', defValue='3000' );
			
			// Slide Transition Speed
			props.slideTransitionSpeed = getStandardField( widgetData=widgetData, field='SlideTransitionSpeed', defValue='1000' );
			
			// Slide Transition Effect
			props.slideTransitionEffect = getStandardField( widgetData=widgetData, field='SlideTransitionEffect', defValue='slide' );
			
			// Pagination Style
			props.paginationStyle = getStandardField( widgetData=widgetData, field='Pagination_Style', defValue='bullets' );
			
			// Pagination Alignment
			props.paginationAlignment = getStandardField( widgetData=widgetData, field='Pagination_Alignment', defValue='bullets' );
			if( props.paginationStyle eq 'none' OR props.paginationStyle eq 'progressbar' )
				props.paginationAlignment = '';			
			
			/**********************************/
			/**** GENERAL PROPERTIES TAB ******/
			/**********************************/

			// Element
			props.element = getFieldSettings(widgetData=widgetData, field='Overall', defShow='no', defBgColor='' );	
			
			// Background Image
			props.backgroundImage = getStandardMetadataImageField( widgetData=widgetData, field='Background_Image', defValue='' );		
			
			// Background Image Focal Point
			props.backgroundImageFocalPoint = getStandardField( widgetData=widgetData, field='Background_Image_Focal_Point', defValue='' );		

			
			/********************************/		
			/**** BUTTON PROPERTIES TAB *****/
			/********************************/
			
			// Position
			props.buttonPosition = getStandardField(widgetData=widgetData, field='Button_Position', defValue='cswHidden');	
			
			// Link Text					
			props.linkText = getStandardField(widgetData=widgetData, field='linkText', defValue='');	

			// Button Type
			props.buttonType = getStandardField( widgetData=widgetData, field='Button_Type', defValue='cswButton' );

			// Button (STRUCT)
			props.button = getFieldSettings(widgetData=widgetData, field='Button', defShow='1', defColor='white', defBgColor='black', defSize='cswBtnSize-normal', defStyle='cswBtn-filled');

			// Button_Corners
			props.buttonCorners = getStandardField( widgetData=widgetData, field='Button_Corners', defValue='cswBtn-rounded' );
			
			// Link (STRUCT)
			props.link = getFieldSettings(widgetData=widgetData, field='Link', defShow='0', defColor='inherit', defSize='cswBtnSize-normal', defStyle='');
			
			// Icon 
			props.buttonIcon = getStandardField( widgetData=widgetData, field='Icon' );

			return props;
		</cfscript>

	</cffunction>
	
	
	
	<!------------------------
		Get And Render Items
	-------------------------->	
	<cffunction name="getAndRenderItems" access="public" output="Yes" returntype="void">
		<cfargument name="elementDataStruct" type="struct" required="Yes">
		<cfargument name="propsStruct" type="struct" required="Yes">
		<cfargument name="elementUniqueID" type="string" required="Yes">
		
		<cfscript>
			var elementID = arguments.elementUniqueID;
			var elementData = arguments.elementDataStruct;
			var props = arguments.propsStruct;
			var data = StructNew();
			var items = ArrayNew(1);		
			var totalItems = 0;
			var slideNumber = 0;
			var adjuster = 20;
			var thumbsArray = ArrayNew(1);
			var html = '';
			var i = 0;
			var styleAttr = '';
			var outerClasses = '';
			
			// Get Records from the Element as an Array of Structures
			if ( StructKeyExists(elementData, 'PropertyValues') AND ArrayLen(elementData.PropertyValues) )
				items = elementData.PropertyValues;
			
			totalItems = ArrayLen(items);
			
			
			styleAttr = '';
			if( structKeyExists(props,'element') )
			{
				if( len(props.element.padding) )
					styleAttr = styleAttr & 'padding: #props.element.padding#;';
				if( len(props.element.bgColor) )
					styleAttr = styleAttr & 'background-color: #props.element.bgColor#;';
			}
			
			if( StructKeyExists(props,'backgroundImage') AND len(props.backgroundImage) )
				styleAttr = styleAttr & "background-image: url('#props.backgroundImage#'); background-repeat: no-repeat; background-size: cover;";
			
			if( StructKeyExists(props,'backgroundImageFocalPoint') )
				outerClasses = trim( outerClasses & ' #props.backgroundImageFocalPoint#');			
			
			if( len(styleAttr) )
				styleAttr = 'style="#styleAttr#"';			
		</cfscript>

		<cfif totalItems>
		
			<cfoutput>
			<div class="heroCarousel #outerClasses#" #styleAttr#>
				<div class="swiper-container swiper-container-#elementid# #props.fixedHeightClass# swiper-container-horizontal">
		   		<div class="swiper-wrapper">	
					</cfoutput>
					
					<cfscript>
						//
						// Loop over each record and output a 'card'
						//
						for( i=1; i lte totalItems; i=i+1 )
						{
							adjuster = 20;
							
							// Get Data
							data = getItemData(items[i].values); 
							
							// RENDER the Icon Textblock container
							html = renderSlide( data, props, i );
							ArrayAppend(thumbsArray, html);
						}
					</cfscript>					
						
					<cfoutput></div></cfoutput>		<!--- end slide wrapper --->
		
					<!--- Add Pagination --->
					<cfif props.paginationStyle neq 'none'>
						<cfoutput><div class="swiper-pagination #props.paginationAlignment#"></div></cfoutput>
					</cfif>
					
					<!--- Add Scrollbar --->
    				<!--- <div class="swiper-scrollbar"></div> --->
					
					<!--- Carousel Arrows --->
					<cfif props.showarrows>
						<cfoutput>
		               <div class="swiper-button-next">&rsaquo;</div>
		               <div class="swiper-button-prev">&lsaquo;</div>
						</cfoutput>
					</cfif>

				<cfoutput></div></cfoutput>		<!--- end hero carousel --->
				
			<!----// THUMBS //---------->
			<cfif props.showThumbs>
				#RenderThumbs(thumbsArray)#
			</cfif>
					
			<cfoutput></div></cfoutput>		<!--- end hero carousel --->				

			<cfset args = "'#elementID#',#props.infiniteloop#,#adjuster#,#props.autoplay#,'#props.SlideTransitionEffect#',#props.slideWaitTime#,#props.slideTransitionSpeed#,#props.showThumbs#,#props.autoheight#,'#props.paginationStyle#'">
	 
			<cfsavecontent variable="cswCarouselJS">
			 	<cfoutput>
				jQuery( document ).ready(function() {
						initHeroCarousel(#args#);
				  });
				</cfoutput>
			</cfsavecontent>
			
			<cfscript>
				// Load custom javascript at the bottom of the page.	
				Server.CommonSpot.udf.resources.addFooterJS(cswCarouselJS, 'TERTIARY');
			</cfscript>
				
		</cfif>

	</cffunction>
	
	
	
	<!----------------------------------------
		Render Item Data (Struct)
	----------------------------------------->
	<cffunction name="getItemData" access="public" output="Yes" returntype="struct">
		<cfargument name="valuesStruct" type="struct" required="Yes">
		
		<cfscript>
			var data = StructNew();
			var values = arguments.valuesStruct;
			
			/********************/
			/* Slide & Image Properties */
			/********************/

			// SlideBackgroundColor			
			data.SlideBackgroundColor = getFieldSettings(widgetData=values, field='SlideBackgroundColor', defBgColor='rgb(255,255,255)');			
			
			// Image - could be straight URL or Structure
			data.imgURL = getStandardCustomElementImageField(widgetData=values, field='image', defValue='');

			// Image Focal Point (optional)
			data.imageFocalPoint = getStandardField(widgetData=values, field='Image_Focal_Point', defValue='cswImgPos-centermiddle');
			
			
			/********************/
			/* Title Properties */
			/********************/

			// Title Position
			data.titlePosition = getStandardField(widgetData=values, field='titlePosition', defValue='cswTextAlignMiddleCenter');
				
			// Title
			data.title = getStandardField(widgetData=values, field='title', defValue='');
			
			// Title Appearance
			data.titleStyle = getFieldSettings(widgetData=values, field='TitleStyle', defShow='no' );				

			
			/**************************/
			/* Description Properties */
			/**************************/

			// Desc Position
			data.descriptionPosition = getStandardField(widgetData=values, field='DescriptionPosition', defValue='cswTextAlignMiddleCenter');
				
			// Desc
			data.description = getStandardField(widgetData=values, field='Description', defValue='');
			
			// Desc Appearance	
			data.descriptionStyle = getFieldSettings(widgetData=values, field='DescriptionStyle' );

			
			/*********************/
			/* Button Properties */
			/*********************/
			
			// Target URL 	
			data.linkURL = getStandardCustomElementLinkField(widgetData=values, field='LinkURL', defValue='');
						
			// Link Url Target					
			data.LinkTarget = getStandardCustomElementLinkFieldTarget(widgetData=values, field='LinkURL', defValue='');
			
			// Link Url OnClick					
			data.onClick = getStandardCustomElementLinkFieldOnClick(widgetData=values, field='LinkURL', defValue='');
			
			// Position (Return Empty String if not mapped)
			data.buttonPosition = getStandardField(widgetData=values, field='ButtonPosition', defValue='');
			
			// Link/Button Text					
			data.linkText = getStandardField(widgetData=values, field='linkText', defValue='');
				
			// Button Type
			data.buttonType = getStandardField( widgetData=values, field='ButtonType', defValue='cswButton' );

			// Button (STRUCT - returns Empty Struct if not mapped ) 
			data.button = getDataFieldSettings(widgetData=values, field='ButtonStyle', defShow='0', defColor='white', defBgColor='black', defSize='cswBtnSize-normal', defStyle='cswBtn-filled');

			// Button_Corners
			data.buttonCorners = getStandardField( widgetData=values, field='Button_Corners', defValue='cswBtn-rounded' );

			// Link (STRUCT - returns Empty Struct if not mapped ) 
			data.link = getDataFieldSettings(widgetData=values, field='LinkStyle', defShow='0', defColor='inherit', defSize='cswBtnSize-normal', defStyle='');
			
			// Icon
			data.buttonIcon = getStandardField( widgetData=values, field='ButtonIcon', defValue='' );

			return data;
		</cfscript>
		
	</cffunction>
	
	
	<cffunction name="RenderSlide" access="private" output="Yes" returntype="string">
		<cfargument name="dataStruct" required="Yes" type="struct">
		<cfargument name="propsStruct" required="Yes" type="struct">
		<cfargument name="item" required="Yes" type="numeric">
		
		<cfscript>
			var data = arguments.dataStruct;
			var props = arguments.propsStruct;
			var itm = arguments.item;
			var itemDivStyles = '';
			var itemClasses = '';
			var adjuster = 20;
			var thumbsHTML = '';
			var renderedButton = 0;
			var buttonPosition = 'cswHidden';
			var bgColor = 'rgb(255,255,255)';
			var styleAttr = '';

			if ( StructKeyExists(data,"buttonPosition") AND len(data.buttonPosition) )
				buttonPosition = data.buttonPosition;
			else if ( StructKeyExists(props,"buttonPosition") AND len(props.buttonPosition) )
				buttonPosition = props.buttonPosition;

		 	if( len(data.linkURL) )
				adjuster = 40; // we have a button so we need to adjust the position of the description text so they don't overlay each other
			
			if( props.showThumbs )	
			{
				thumbsHTML = '<div class="swiper-slide cswThumb"><div class="cswPhotoBox #data.imageFocalPoint#" style="background-image:url(#data.imgURL#);" data-cswSlide="#arguments.item#"></div></div>';
			}	
			
			if( StructKeyExists(data, 'SlideBackgroundColor') AND Len(data.SlideBackgroundColor.bgColor) )
				bgColor = data.slideBackgroundColor.bgColor;
			
			styleAttr = 'style="background-color:#bgColor#;"';
		</cfscript>
		

		<cfoutput>
			<div class="swiper-slide" #styleAttr#>
				<div class="cswPhotoBox #data.imageFocalPoint#" style="background-image:url(#data.imgURL#);"></div>
				</cfoutput>
				
				<cfif data.titlePosition EQ data.descriptionPosition>
				
					<!--- Title & Description are placed Together --->
					<cfoutput>
					<div class="cswTextBox #data.titlePosition#">
						<div class="cswTitleBox">
							#RenderSlideTitle(data, props, arguments.item)#
						</div>
						
						<div class="cswDescWrapper slidenumber#arguments.item#">
							#RenderSlideDescription(data, props, arguments.item)#
						</div>
						
						<cfif data.titlePosition EQ buttonPosition>
							<div class="cswLinkButton #props.dotsClass#">
								#RenderSlideButton(data,props,arguments.item)#
							</div>
							<cfset renderedButton = 1>
						</cfif>
					</div>
					</cfoutput>
					
				<cfelse>
				
					<!--- Title & Description are placed a part --->
					
					<!---// Render Title //--->
					<cfif data.titlePosition NEQ "Hidden">

						<!--- Title & Button are at same position --->						
						<cfif data.titlePosition EQ buttonPosition>
							<cfoutput>
							<div class="cswTextBox #data.titlePosition#"> 
								<div class="cswTitleBox">
									#RenderSlideTitle(data, props, arguments.item)#
								</div>
						
								<div class="cswLinkButton #props.dotsClass#">
									#RenderSlideButton(data,props,arguments.item)#
								</div>
								<cfset renderedButton = 1>
							</div>
							</cfoutput>
						<cfelse>
							<cfoutput>
							<div class="cswTitleBox #data.titlePosition# #data.titleStyle.align#">
								#RenderSlideTitle(data, props, arguments.item)#
							</div>	
							</cfoutput>							
						</cfif>
						
					</cfif>
					
					<!---// Render Description //--->
					<cfif len(data.description) AND data.descriptionPosition NEQ "Hidden">
					
						<!--- Desc & Button are at same position --->						
						<cfif data.descriptionPosition EQ buttonPosition>
							<cfoutput>
							<div class="cswTextBox #data.descriptionPosition#"> 
								<div class="cswDescription slidenumber#arguments.item#">
									#RenderSlideDescription(data, props, arguments.item)#	
								</div>
										
								<div class="cswLinkButton #props.dotsClass#">
									#RenderSlideButton(data,props,arguments.item)#
								</div>
								<cfset renderedButton = 1>
							</div>
							</cfoutput>
						<cfelse>
							<cfoutput>
							<div class="cswDescription #data.descriptionPosition# slidenumber#arguments.item#">
								#RenderSlideDescription(data, props, arguments.item)#	
							</div>	
							</cfoutput>							
						</cfif>

					</cfif>
					
				</cfif>

				<cfif renderedButton eq 0>
					<cfoutput>
					<div class="cswLinkButton #buttonPosition# #props.dotsClass#">
						#RenderSlideButton(data,props,arguments.item)#
					</div>
					</cfoutput>				
				</cfif>
				
			<cfoutput></div></cfoutput>
			
			<cfreturn thumbsHTML>

	</cffunction>	
	
	
	<cffunction name="renderSlideTitle" access="private" output="Yes" returntype="void">
		<cfargument name="dataStruct" required="Yes" type="struct">
		<cfargument name="propsStruct" required="Yes" type="struct">
		<cfargument name="item" required="Yes" type="numeric">
		
		<cfscript>
			var data = arguments.dataStruct;
			var props = arguments.propsStruct;
			var bgColor = data.titleStyle.bgColor;
			var linkOnClick = '';
			var linkAttrStruct = {};
			var linkTarget = '';
		</cfscript>
		
		<cfif data.titlePosition NEQ "Hidden">
		
			<cfscript>
				// Add opacity
				if( len(data.titleStyle.style) )
					bgColor = GetRGBAColor(bgColor, data.titleStyle.style );
					
				if ( StructKeyExists(data,"onClick") )
					linkOnClick = data.onClick;
				if ( StructKeyExists(data,"linkAttrStruct") )
					linkAttrStruct = data.linkAttrStruct;
				if ( StructKeyExists(data,"linkTarget") )
					linkTarget = data.linkTarget;
			
				RenderTextCore(
					class = 'cswTitle',
					tag = data.titleStyle.tag,
					text = data.title,
					color = data.titleStyle.color,
					backgroundColor = bgColor,
					size = data.titleStyle.size,
					align = data.titleStyle.align,
					fontClasses = data.titleStyle.fontClasses,
					padding = data.titleStyle.padding,
					effect = data.titleStyle.effect,
					linkURL = data.linkURL,
					style = '',
					onClick = linkOnClick,
					linkAttrStruct = linkAttrStruct,
					linkTarget = linkTarget
				);
			</cfscript>
			
		</cfif>
	
	</cffunction>
	

	
	<cffunction name="renderSlideDescription" access="private" output="Yes" returntype="void">
		<cfargument name="dataStruct" required="Yes" type="struct">
		<cfargument name="propsStruct" required="Yes" type="struct">
		<cfargument name="item" required="Yes" type="numeric">
		
		<cfscript>
			var data = arguments.dataStruct;
			var props = arguments.propsStruct;
			var bgColor = data.descriptionStyle.bgColor;
		</cfscript>
	
		<cfif len(data.description) AND data.descriptionPosition NEQ "Hidden">
			
			<cfscript>
				// Add opacity
				if( len(data.descriptionStyle.style) )
					bgColor = GetRGBAColor(bgColor, data.descriptionStyle.style );
				
				RenderTextCore(
					class = 'cswDesc',
					tag = data.descriptionStyle.tag,
					text = data.description,
					color = data.descriptionStyle.color,
					backgroundColor = bgColor,
					size = data.descriptionStyle.size,
					align = data.descriptionStyle.align,
					fontClasses = data.descriptionStyle.fontClasses,
					padding = data.descriptionStyle.padding,
					effect = data.descriptionStyle.effect,
					linkURL = '',
					style = ''
				);
			</cfscript>
						
		</cfif>
	
	</cffunction>
	
	
	<cffunction name="renderSlideButton" access="private" output="Yes" returntype="void">
		<cfargument name="dataStruct" required="Yes" type="struct">
		<cfargument name="propsStruct" required="Yes" type="struct">		
		<cfargument name="item" required="Yes" type="numeric">	
		
		<cfscript>
			var data = arguments.dataStruct;
			var props = arguments.propsStruct;
		</cfscript>
		
		<cfoutput>
			#RenderButton(data, props)#				
		</cfoutput>
		
	</cffunction>
	
	
	
	<cffunction name="RenderThumbs" access="private" output="Yes" returntype="void">
		<cfargument name="thumbsArray" required="Yes" type="array">	
		
		<cfscript>
			var thumbs = arguments.thumbsArray;
			var i = 0;
		</cfscript>
	
		<cfoutput>
		<div class="heroCarouselThumbs swiper-container swiper-thumbs swiper-container-#request.element.id#-thumbs swiper-container-horizontal">
   		<div class="swiper-wrapper">	
				</cfoutput>
					
				<cfloop index="i" from="1" to="#ArrayLen(thumbs)#" step="1">
					<cfoutput>#thumbs[i]#</cfoutput>
				</cfloop>
				
				<cfoutput>	
			</div>
		</div>	
		</cfoutput>
	
	</cffunction>
	
</cfcomponent>